#include <LiquidCrystal_I2C.h>

#include <Wire.h> 

#include <avr/wdt.h>
 
LiquidCrystal_I2C lcd(0x27,16,2);  // устанавливаем адрес 0x27, и дисплей 16 символов в 2 строки (16х2)

#define LED_PINS 2        // для пинга со второго контроллера моргает 3 раза

#define BUTTON_PINA 3     // реле 1
#define BUTTON_PINB 4     // реле 2
#define BUTTON_PINC 5     // реле 3
#define BUTTON_PIND 6     // реле 4
#define BUTTON_PINE 7     // реле 5
#define BUTTON_PINF 8     // реле 6
#define BUTTON_PING 9     // реле 7
#define BUTTON_PINH 11    // реле 8


#define RXTX_PIN 17       // RXTX ACTIVATION

#define DEBOUNCE_TIME 5

int _previousValueA = 0;
int _previousValueB = 0;
int _previousValueC = 0;
int _previousValueD = 0;
int _previousValueE = 0;
int _previousValueF = 0;
int _previousValueG = 0;
int _previousValueH = 0;

int currentValueA;
int currentValueB;
int currentValueC;
int currentValueD;
int currentValueE;
int currentValueF;
int currentValueG;
int currentValueH;



void setup() 
{
  Serial.begin(9600);
  
  pinMode(LED_PINS, OUTPUT);


  pinMode(BUTTON_PINA, INPUT);
  pinMode(BUTTON_PINB, INPUT);
  pinMode(BUTTON_PINC, INPUT);
  pinMode(BUTTON_PIND, INPUT);
  pinMode(BUTTON_PINE, INPUT);
  pinMode(BUTTON_PINF, INPUT);
  pinMode(BUTTON_PING, INPUT);
  pinMode(BUTTON_PINH, INPUT);
  

  
  pinMode(RXTX_PIN, OUTPUT);  // RXTX предназначен для активациии режима приёма RS485
  

  _previousValueA = digitalRead(BUTTON_PINA);
  _previousValueB = digitalRead(BUTTON_PINB);
  _previousValueC = digitalRead(BUTTON_PINC);
  _previousValueD = digitalRead(BUTTON_PIND);
  _previousValueE = digitalRead(BUTTON_PINE);
  _previousValueF = digitalRead(BUTTON_PINF);
  _previousValueG = digitalRead(BUTTON_PING);
  _previousValueH = digitalRead(BUTTON_PINH);

  

  digitalWrite(LED_PINS, LOW);
  digitalWrite(RXTX_PIN, LOW);

  wdt_enable(WDTO_8S);          // 8 сек
}


//-------------------------------------------------------------------------------------
// ниже приведены действи при изменениях на восьми входах

//-------------------------------------------------------------------------------------
void loop()
{

  
  int currentValueA = digitalRead(BUTTON_PINA);
  int currentValueB = digitalRead(BUTTON_PINB);
  int currentValueC = digitalRead(BUTTON_PINC);
  int currentValueD = digitalRead(BUTTON_PIND);
  int currentValueE = digitalRead(BUTTON_PINE);
  int currentValueF = digitalRead(BUTTON_PINF);
  int currentValueG = digitalRead(BUTTON_PING);
  int currentValueH = digitalRead(BUTTON_PINH);


  
  if(Serial.available()>0)
  {
    char letter = Serial.read();

// условие серийного порта для проверки состояния портов
    if (letter == 'a' || letter == 'b')              // это получение кода опроса 1 контакта
    {
         if (currentValueA == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('Q');
           delay(1);
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('q');
           delay(1);
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'r' || letter == 'd')              // это получение кода опроса 2 контакта
    {
         if (currentValueB == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('Y');
           delay(1);
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('y');
           delay(1);
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'e' || letter == 'f')              // это получение кода опроса 3 контакта
    {
         if (currentValueC == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('S');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('s');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'g' || letter == 'h')              // это получение кода опроса 4 контакта
    {
         if (currentValueD == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('T');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('t');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'i' || letter == 'j')              // это получение кода опроса 5 контакта
    {
         if (currentValueE == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('U');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('u');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'k' || letter == 'l')              // это получение кода опроса 6 контакта
    {
         if (currentValueF == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('V');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('v');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'm' || letter == 'n')              // это получение кода опроса 7 контакта
    {
         if (currentValueG == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('W');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('w');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
    if (letter == 'o' || letter == 'p')              // это получение кода опроса 8 контакта
    {
         if (currentValueH == HIGH)
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('X');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
         else
         {
           digitalWrite(RXTX_PIN, HIGH);
           Serial.print('x');
           delay(1);
           //lcd.setCursor(12, 1);           
           //lcd.print("FIRE");
           digitalWrite(RXTX_PIN, LOW);
         }
    }
//--------------------------------------------------------------------------------------------------
         
    if (letter == 'Z')              // это получение кода от кнопки проверки на втором устройстве
    {
      SobitiePING();
    }
  } 
//-------------------------------------------------------------------------------
// A
  
  
  if (_previousValueA != currentValueA)
  {
    if (currentValueA == HIGH)
    {
      SobitieAHigh();
    }
    else
    {
      SobitieALow();
    }

    _previousValueA = currentValueA;
  }
//-------------------------------------------------------------------
// B

  if (_previousValueB != currentValueB)
  {
    if (currentValueB == HIGH)
    {
      SobitieBHigh();
    }
    else
    {
      SobitieBLow();
    }
    
    _previousValueB = currentValueB;
  }
//-------------------------------------------------------------------
// C
   
  if (_previousValueC != currentValueC)
  {
    if (currentValueC == HIGH)
    {
      SobitieCHigh();
    }
    else
    {
      SobitieCLow();
    }
    

    _previousValueC = currentValueC;
  }
//-------------------------------------------------------------------
// D
   
  if (_previousValueD != currentValueD)
  {
    if (currentValueD == HIGH)
    {
      SobitieDHigh();
    }
    else
    {
      SobitieDLow();
    }
 
    _previousValueD = currentValueD;
  }
//-------------------------------------------------------------------
// E
   
  if (_previousValueE != currentValueE)
  {
    if (currentValueE == HIGH)
    {
      SobitieEHigh();
    }
    else
    {
      SobitieELow();
    }
 
    _previousValueE = currentValueE;
  }
//-------------------------------------------------------------------
// F
  if (_previousValueF != currentValueF)
  {
    if (currentValueF == HIGH)
    {
      SobitieFHigh();
    }
    else
    {
      SobitieFLow();
    }
 
    _previousValueF = currentValueF;
  }
//-------------------------------------------------------------------
// G

  if (_previousValueG != currentValueG)
  {
    if (currentValueG == HIGH)
    {
      SobitieGHigh();
    }
    else
    {
      SobitieGLow();
    }
 
    _previousValueG = currentValueG;
  }
//-------------------------------------------------------------------
// H
   
  if (_previousValueH != currentValueH)
  {
    if (currentValueH == HIGH)
    {
      SobitieHHigh();
    }
    else
    {
      SobitieHLow();
    }
 
    _previousValueH = currentValueH;
  }
//-------------------------------------------------------------------


  delay(DEBOUNCE_TIME);
  wdt_reset();  // сброс сторожевого таймера  
  
} //loop
